// -----------------------------------------------------------------------------------
//
// javaFish.CPP                                             Ulrich Mller    25.10.01
//                                                          Procida 400NT    VC++ 6.0
//
// Wrapper-DLL fr umFish20.DLL zu Nutzung aus Java 
//
// ------------------------------------------------------------------------------------

# include <windows.h>
# include "jni.h"
# include "umFish20VC.h"
# include "ftcomputing_JavaFish.h"

ftiDCB Interface[4];


JNIEXPORT jint JNICALL Java_ftcomputing_JavaFish_jcOpenInterface
  (JNIEnv *env, jobject obj, jint iNr, jstring PortName){
	
DWORD res;

  const char* PN = env->GetStringUTFChars(PortName, NULL);
  res = umOpenInterface(Interface[iNr], PN);
  env->ReleaseStringUTFChars(PortName, PN);
  return(res);
}

JNIEXPORT jint JNICALL Java_ftcomputing_JavaFish_jcCloseInterface
  (JNIEnv *env, jobject obj, jint iNr){
	return(umCloseInterface(Interface[iNr]));
}

JNIEXPORT jint JNICALL Java_ftcomputing_JavaFish_getVersion(JNIEnv *, jobject){
	return(201);
}

JNIEXPORT jint JNICALL Java_ftcomputing_JavaFish_jcGetInput
  (JNIEnv *env, jobject obj, jint iNr, jint InputNr){
	return(umGetInput(Interface[iNr], InputNr));
}

JNIEXPORT jint JNICALL Java_ftcomputing_JavaFish_jcSetMotor
  (JNIEnv *env, jobject obj , jint iNr, jint MotorNr, jint Direction){
	return(umSetMotor(Interface[iNr], MotorNr, Direction));
}

JNIEXPORT jint JNICALL Java_ftcomputing_JavaFish_jcSetLamp
  (JNIEnv *env, jobject obj, jint iNr, jint LampNr, jint OnOff){
	return(umSetLamp(Interface[iNr], LampNr, OnOff));
}

JNIEXPORT void JNICALL Java_ftcomputing_JavaFish_jcSetDCB
  (JNIEnv *env, jobject obj, jint iNr, jint Index, jint Wert){
  switch(Index) {
	case 0: 
      Interface[iNr].hCom = (HANDLE)Wert; break;
	case 1:
	  Interface[iNr].PortID = Wert; break;
	case 2:
	  Interface[iNr].LPTDelay = Wert; break;
	case 3:
	  Interface[iNr].LPTAnalog = Wert; break;
	case 4:
	  Interface[iNr].ECount = Wert; break;
	case 5:
	  Interface[iNr].FID = (MMRESULT)Wert; break;
	case 6:
	  Interface[iNr].PollInterval = Wert; break;
	case 7:
	  Interface[iNr].AnalogScan = Wert; break;
	case 8:
	  Interface[iNr].OutputStatus = Wert; break;
	case 9:
	  Interface[iNr].InputStatus = Wert; break;
	case 10:
	  Interface[iNr].Analogs[0] = Wert; break;
	case 11:
	  Interface[iNr].Analogs[1] = Wert; break;
	default:
	  Interface[iNr].Counters[Index-12] = Wert; break;
	}
}

JNIEXPORT jint JNICALL Java_ftcomputing_JavaFish_jcGetDCB
  (JNIEnv *env, jobject obj, jint iNr, jint Index){
  jint res;
  switch(Index) {
    case 0: 
	  res = (jint)Interface[iNr].hCom; break;
	case 1:
	  res = Interface[iNr].PortID; break;
	case 2:
	  res = Interface[iNr].LPTDelay; break;
	case 3:
	  res = Interface[iNr].LPTAnalog; break;
	case 4:
	  res = Interface[iNr].ECount; break;
	case 5:
	  res = (jint)Interface[iNr].FID; break;
	case 6:
	  res = Interface[iNr].PollInterval; break;
	case 7:
	  res = Interface[iNr].AnalogScan; break;
	case 8:
	  res = Interface[iNr].OutputStatus; break;
	case 9:
	  res = Interface[iNr].InputStatus; break;
	case 10:
	  res = Interface[iNr].Analogs[0]; break;
	case 11:
	  res = Interface[iNr].Analogs[1]; break;
	default:
	  res = Interface[iNr].Counters[Index-12]; break;
	}
	return(res);
}

JNIEXPORT void JNICALL Java_ftcomputing_JavaFish_jcSleep
(JNIEnv *env, jobject obj, jint MilliSec){
  Sleep(MilliSec);
}

JNIEXPORT jboolean JNICALL Java_ftcomputing_JavaFish_jcEscape(JNIEnv *env, jobject obj){
  return(jboolean(GetAsyncKeyState(VK_ESCAPE) != 0));
}